// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Java Management Service Query API
//
// API for the Java Management Service. Use this API to view and manage Fleets.
//

package jms

import (
	"github.com/oracle/oci-go-sdk/v46/common"
)

// ApplicationUsage Application usage during a specified time period.
// An application is a Java application that can be executed by a Java Runtime installation.
// An application is independent of the Java Runtime or its installation.
type ApplicationUsage struct {

	// An internal identifier for the application that is unique to a Fleet.
	ApplicationId *string `mandatory:"true" json:"applicationId"`

	// The name of the application.
	DisplayName *string `mandatory:"true" json:"displayName"`

	// The type of the application, denoted by how the application was started.
	ApplicationType *string `mandatory:"true" json:"applicationType"`

	// The approximate count of installations running this application.
	ApproximateInstallationCount *int `mandatory:"false" json:"approximateInstallationCount"`

	// The approximate count of Java Runtimes running this application.
	ApproximateJreCount *int `mandatory:"false" json:"approximateJreCount"`

	// The approximate count of managed instances reporting this application.
	ApproximateManagedInstanceCount *int `mandatory:"false" json:"approximateManagedInstanceCount"`

	// Lower bound of the specified time period filter.
	TimeStart *common.SDKTime `mandatory:"false" json:"timeStart"`

	// Upper bound of the specified time period filter.
	TimeEnd *common.SDKTime `mandatory:"false" json:"timeEnd"`

	// The date and time the resource was _first_ reported to JMS.
	// This is potentially _before_ the specified time period provided by the filters.
	// For example, a resource can be first reported to JMS before the start of a specified time period,
	// if it is also reported during the time period.
	TimeFirstSeen *common.SDKTime `mandatory:"false" json:"timeFirstSeen"`

	// The date and time the resource was _last_ reported to JMS.
	// This is potentially _after_ the specified time period provided by the filters.
	// For example, a resource can be last reported to JMS before the start of a specified time period,
	// if it is also reported during the time period.
	TimeLastSeen *common.SDKTime `mandatory:"false" json:"timeLastSeen"`
}

func (m ApplicationUsage) String() string {
	return common.PointerString(m)
}
