// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v46/common"
)

// ExportHostVulnerabilityCsvDetails Details for a Host Vulnerability list export to CSV action
type ExportHostVulnerabilityCsvDetails struct {

	// The OCID (https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the compartment to list vulnerabilities in.
	CompartmentId *string `mandatory:"true" json:"compartmentId"`

	// Date and time on or after which this vulnerability was last detected, as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeLastDetectedGreaterThanOrEqualTo *common.SDKTime `mandatory:"true" json:"timeLastDetectedGreaterThanOrEqualTo"`

	// Date and time on or before which this vulnerability was last detected, as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeLastDetectedLessThanOrEqualTo *common.SDKTime `mandatory:"true" json:"timeLastDetectedLessThanOrEqualTo"`
}

func (m ExportHostVulnerabilityCsvDetails) String() string {
	return common.PointerString(m)
}
