// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v46/common"
)

// HostAgentScanResultProblem A problem found in a host agent scan
type HostAgentScanResultProblem struct {

	// Name of the problem
	Name *string `mandatory:"true" json:"name"`

	// Problem severity
	Severity ScanResultProblemSeverityEnum `mandatory:"true" json:"severity"`

	// Problem description
	Description *string `mandatory:"false" json:"description"`

	// State of the vulnerability
	State ScanResultVulnerabilityStateEnum `mandatory:"false" json:"state,omitempty"`

	// Reference to problem MITRE CVE ID
	CveReference *string `mandatory:"false" json:"cveReference"`

	// Reference to problem issue ID
	IssueId *int `mandatory:"false" json:"issueId"`

	// Date of scan result that first reported the vulnerability
	TimeFirstDetected *common.SDKTime `mandatory:"false" json:"timeFirstDetected"`

	// Date of scan result that most recently reported the vulnerability
	TimeLastDetected *common.SDKTime `mandatory:"false" json:"timeLastDetected"`
}

func (m HostAgentScanResultProblem) String() string {
	return common.PointerString(m)
}
