// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

// HostAgentScanResultSortByEnum Enum with underlying type: string
type HostAgentScanResultSortByEnum string

// Set of constants representing the allowable values for HostAgentScanResultSortByEnum
const (
	HostAgentScanResultSortByTimeStarted            HostAgentScanResultSortByEnum = "timeStarted"
	HostAgentScanResultSortByTimeFinished           HostAgentScanResultSortByEnum = "timeFinished"
	HostAgentScanResultSortByProblemCount           HostAgentScanResultSortByEnum = "problemCount"
	HostAgentScanResultSortByHighestProblemSeverity HostAgentScanResultSortByEnum = "highestProblemSeverity"
	HostAgentScanResultSortByTimeCompleted          HostAgentScanResultSortByEnum = "timeCompleted"
)

var mappingHostAgentScanResultSortBy = map[string]HostAgentScanResultSortByEnum{
	"timeStarted":            HostAgentScanResultSortByTimeStarted,
	"timeFinished":           HostAgentScanResultSortByTimeFinished,
	"problemCount":           HostAgentScanResultSortByProblemCount,
	"highestProblemSeverity": HostAgentScanResultSortByHighestProblemSeverity,
	"timeCompleted":          HostAgentScanResultSortByTimeCompleted,
}

// GetHostAgentScanResultSortByEnumValues Enumerates the set of values for HostAgentScanResultSortByEnum
func GetHostAgentScanResultSortByEnumValues() []HostAgentScanResultSortByEnum {
	values := make([]HostAgentScanResultSortByEnum, 0)
	for _, v := range mappingHostAgentScanResultSortBy {
		values = append(values, v)
	}
	return values
}
