// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

// HostPortScanLevelEnum Enum with underlying type: string
type HostPortScanLevelEnum string

// Set of constants representing the allowable values for HostPortScanLevelEnum
const (
	HostPortScanLevelNone     HostPortScanLevelEnum = "NONE"
	HostPortScanLevelLight    HostPortScanLevelEnum = "LIGHT"
	HostPortScanLevelStandard HostPortScanLevelEnum = "STANDARD"
)

var mappingHostPortScanLevel = map[string]HostPortScanLevelEnum{
	"NONE":     HostPortScanLevelNone,
	"LIGHT":    HostPortScanLevelLight,
	"STANDARD": HostPortScanLevelStandard,
}

// GetHostPortScanLevelEnumValues Enumerates the set of values for HostPortScanLevelEnum
func GetHostPortScanLevelEnumValues() []HostPortScanLevelEnum {
	values := make([]HostPortScanLevelEnum, 0)
	for _, v := range mappingHostPortScanLevel {
		values = append(values, v)
	}
	return values
}
