// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v46/common"
)

// HostScanTargetSummary Summary of a host scan target (application of a host scan recipe to a compartment or list of hosts)
type HostScanTargetSummary struct {

	// Unique identifier of the config that is immutable on creation
	Id *string `mandatory:"true" json:"id"`

	// Target identifier, which can be renamed.
	DisplayName *string `mandatory:"true" json:"displayName"`

	// Compartment ID of the object (this).
	CompartmentId *string `mandatory:"true" json:"compartmentId"`

	// Compartment ID to target. If a list of hosts is provided, all hosts must be in this compartment.
	TargetCompartmentId *string `mandatory:"true" json:"targetCompartmentId"`

	// ID of the host scan recipe this target applies.
	HostScanRecipeId *string `mandatory:"true" json:"hostScanRecipeId"`

	// The current state of the config.
	LifecycleState LifecycleStateEnum `mandatory:"true" json:"lifecycleState"`

	// Date and time the target was created, format as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeCreated *common.SDKTime `mandatory:"true" json:"timeCreated"`

	// Date and time the target was last updated, format as described in RFC 3339 (https://tools.ietf.org/rfc/rfc3339)
	TimeUpdated *common.SDKTime `mandatory:"true" json:"timeUpdated"`

	// List of compute instance IDs to target (optional). If empty, targets the entire targetCompartmentId.
	InstanceIds []string `mandatory:"false" json:"instanceIds"`

	// Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
	// Example: `{"bar-key": "value"}`
	FreeformTags map[string]string `mandatory:"false" json:"freeformTags"`

	// Defined tags for this resource. Each key is predefined and scoped to a namespace.
	// Example: `{"foo-namespace": {"bar-key": "value"}}`
	DefinedTags map[string]map[string]interface{} `mandatory:"false" json:"definedTags"`

	// Usage of system tag keys. These predefined keys are scoped to namespaces.
	// Example: `{"orcl-cloud": {"free-tier-retained": "true"}}`
	SystemTags map[string]map[string]interface{} `mandatory:"false" json:"systemTags"`
}

func (m HostScanTargetSummary) String() string {
	return common.PointerString(m)
}
